#include"fc2722.h"

#include"E2PROM.h"
#define l1 FP31
#define fog_key FP11
#define light_key FP12



#define send_1 l1=1;delay_5u();delay_5u();l1=0;__asm{nop}__asm{nop};
#define send_0 l1=1;__asm{nop}__asm{nop};l1=0;__asm{nop};delay_5u();
unsigned long led_time=0;

unsigned int send_time=0;
void send(unsigned int number);
void out();
unsigned int car_led[13][3]={
							{8,0,1},
							{7,13,2},
							{6,14,3},
							{11,15,4},
							{10,16,5},
							{9,17,33},
							{18,20,34},
							{23,45,35},
							{22,46,30},
							{21,47,31},
							{29,42,32},
							{28,43,24},
							{27,26,25},
};

unsigned int car_pwm[48]={0};

unsigned int key_count;
void delay(unsigned long time);

void delay_5u()
{}


unsigned int led_mode=1;
unsigned int led_lit_mode;
unsigned int mode_mode=0;
bit zf;

bit ok_flag=0;
bit last_fog_key=0;
bit need;

void first()
{

	unsigned int i;

	i=e2prom_read(2);
	if(i==0x69)
	{
		led_mode=e2prom_read(1);
	}
	else
	{
			e2_c();
		e2prom_write(1,1);
		e2prom_write(2,0x69);
	}
}















void mode1_show()
{
	if(led_time>100)
	{
		led_time=0;
		if(zf)
		{
			led_lit_mode++;
			if(led_lit_mode>11)
			{
				zf=0;
				led_lit_mode=11;
			}

		}
		else
		{
			if(led_lit_mode==0)
			{
				zf=1;
				led_lit_mode=0;
			}
			else
			{
				led_lit_mode--;	
			}	
		}
		unsigned int m,i;
		i=led_lit_mode;
		for(m=0;m<48;m++)
		{
			car_pwm[m]=0;
		}
		if(i==6||i==5)
		{
			car_pwm[19]=255;
			car_pwm[12]=255;
		}


		car_pwm[car_led[i][0]]=255;
		car_pwm[car_led[i][1]]=255;
		car_pwm[car_led[i][2]]=255;
		car_pwm[car_led[i+1][0]]=255;
		car_pwm[car_led[i+1][1]]=255;
		car_pwm[car_led[i+1][2]]=255;
		out();
	}
}





void mode3_show()
{
	if(led_time>100)
	{
		led_time=0;
		if(zf)
		{
			led_lit_mode++;
			if(led_lit_mode>13)
			{
				zf=0;
				led_lit_mode=13;
				mode_mode++;
				if(mode_mode>=2)
				{
					ok_flag=1;
				}
			}

		}
		else
		{
			if(led_lit_mode==0)
			{
				zf=1;
				led_lit_mode=0;
			}
			else
			{
				led_lit_mode--;	
			}	
		}
		unsigned int m,i;
		i=led_lit_mode;
		for(m=0;m<48;m++)
		{
			car_pwm[m]=0;
		}

		for(i=0;i<led_lit_mode;i++)
		{
			car_pwm[car_led[i][0]]=255;
			car_pwm[car_led[i][1]]=255;
			car_pwm[car_led[i][2]]=255;
		
		}
		if(i>6)
		{
			car_pwm[19]=255;
			car_pwm[12]=255;
		}


		out();
	}
}



void mode4_show()
{
	if(led_time>200)
	{
		led_time=0;
		led_lit_mode++;

		unsigned int m,i;
		switch(mode_mode)
		{
			case 0:					//ȫ
					for(m=0;m<48;m++)
					{
						car_pwm[m]=0;
					}
					mode_mode=1;
					led_lit_mode=0;
					break;
			case 1:				//5-0[0]

					car_pwm[car_led[6-led_lit_mode][0]]=255;
					if(led_lit_mode==6)
					{
						mode_mode=2;
						led_lit_mode=0;
					}	
					break;

			case 2:				//0[0]
					car_pwm[0]=255;
					mode_mode=3;
					led_lit_mode=0;
					break;
			case 3:				//0-12[2]
					car_pwm[car_led[led_lit_mode-1][2]]=255;
					if(led_lit_mode==13)
					{
						mode_mode=4;
						led_lit_mode=0;
					}
					break;
			case 4:				//0-12[2]
					car_pwm[26]=255;
					mode_mode=5;
					led_lit_mode=0;
					break;
			case 5:				//12-6[0]
					car_pwm[car_led[13-led_lit_mode][0]]=255;
					if(led_lit_mode==7)
					{
						mode_mode=6;
						led_lit_mode=0;
					}	
					break;

			case 6:				//0-12[2]
					car_pwm[19]=255;
					mode_mode=7;
					led_lit_mode=0;
					break;
			case 7:				//0-12[2]
					car_pwm[20]=255;
					mode_mode=8;
					led_lit_mode=0;
					break;
			case 8:				//0-12[2]
					car_pwm[12]=255;
					mode_mode=9;
					led_lit_mode=0;
					break;

			case 9:				//0-12[2]
					if(led_lit_mode==6)
					{
						led_lit_mode=7;
					}
					car_pwm[car_led[led_lit_mode][1]]=255;
					if(led_lit_mode==11)
					{
						led_lit_mode=0;
						mode_mode=10;

					}
					break;
			default :
						ok_flag=1;
				break;




		}



		out();
	}
}

void mode2_show()
{
	if(led_time>200)
	{
		led_time=0;
		if(zf)
		{
			led_lit_mode++;
			if(led_lit_mode>7)
			{
				zf=0;
				led_lit_mode=7;
			}

		}
		else
		{
			if(led_lit_mode==0)
			{
				zf=1;
				led_lit_mode=0;
			}
			else
			{
				led_lit_mode--;	
			}	
		}
		
		unsigned int m,i;
		i=led_lit_mode;
		for(m=0;m<48;m++)
		{
			car_pwm[m]=0;
		}
	
		car_pwm[20]=255;


		
		switch(led_lit_mode)
		{
			case 0:	break;
			case 1:
						car_pwm[19]=255;
						car_pwm[12]=255;
						car_pwm[17]=255;
						car_pwm[45]=255;
						break;
							
			case 2:
						car_pwm[19]=255;
						car_pwm[12]=255;
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
						}
						car_pwm[car_led[8][1]]=255;
						car_pwm[car_led[4][1]]=255;
						break;

			case 3:
						car_pwm[19]=255;
						car_pwm[12]=255;
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
							car_pwm[car_led[8][i]]=255;
							car_pwm[car_led[4][i]]=255;
						}
						car_pwm[car_led[9][1]]=255;
						car_pwm[car_led[3][1]]=255;
						break;


			case 4:
						car_pwm[19]=255;
						car_pwm[12]=255;
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
							car_pwm[car_led[8][i]]=255;
							car_pwm[car_led[4][i]]=255;
							car_pwm[car_led[9][i]]=255;
							car_pwm[car_led[3][i]]=255;
						}
						car_pwm[car_led[10][1]]=255;
						car_pwm[car_led[2][1]]=255;
						break;


			case 5:
						car_pwm[19]=255;
						car_pwm[12]=255;
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
							car_pwm[car_led[8][i]]=255;
							car_pwm[car_led[4][i]]=255;
							car_pwm[car_led[9][i]]=255;
							car_pwm[car_led[3][i]]=255;
							car_pwm[car_led[10][i]]=255;
							car_pwm[car_led[2][i]]=255;
						}
						car_pwm[car_led[11][1]]=255;
						car_pwm[car_led[1][1]]=255;
						break;

			case 6:
						car_pwm[19]=255;
						car_pwm[12]=255;
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
							car_pwm[car_led[8][i]]=255;
							car_pwm[car_led[4][i]]=255;
							car_pwm[car_led[9][i]]=255;
							car_pwm[car_led[3][i]]=255;
							car_pwm[car_led[10][i]]=255;
							car_pwm[car_led[2][i]]=255;
							car_pwm[car_led[11][i]]=255;
							car_pwm[car_led[1][i]]=255;
						}
						car_pwm[car_led[12][1]]=255;
						car_pwm[car_led[0][1]]=255;
						break;
			case 7:
						for(m=0;m<48;m++)
						{
							car_pwm[m]=255;
						}
						mode_mode++;
						if(mode_mode>=4)
						{
							ok_flag=1;//볣ģʽ
						}
						break;
			default	:led_lit_mode=0;break;
		}



/*




		switch(led_lit_mode)
		{
			case 0:		car_pwm[18]=50;
						car_pwm[34]=50;
						car_pwm[17]=50;
						car_pwm[45]=50;
						break;

			case 1:		
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
						}
						car_pwm[9]=50;
						car_pwm[33]=50;
						car_pwm[23]=50;
						car_pwm[35]=50;	
						car_pwm[16]=50;
						car_pwm[46]=50;
						car_pwm[17]=255;
						car_pwm[45]=255;
						break;
			case 2:		
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
						}
						car_pwm[10]=50;
						car_pwm[15]=50;
						car_pwm[5]=50;
						car_pwm[22]=50;	
						car_pwm[47]=50;
						car_pwm[30]=50;
						car_pwm[46]=255;
						car_pwm[16]=255;
						break;
			case 3:		
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
							car_pwm[car_led[4][i]]=255;
							car_pwm[car_led[8][i]]=255;
						}
						car_pwm[11]=50;
						car_pwm[14]=50;
						car_pwm[4]=50;
						car_pwm[21]=50;	
						car_pwm[42]=50;
						car_pwm[31]=50;
						car_pwm[47]=255;
						car_pwm[15]=255;
						break;


			case 4:		
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
							car_pwm[car_led[4][i]]=255;
							car_pwm[car_led[8][i]]=255;
							car_pwm[car_led[3][i]]=255;
							car_pwm[car_led[9][i]]=255;
						}
						car_pwm[6]=50;
						car_pwm[13]=50;
						car_pwm[3]=50;
						car_pwm[29]=50;	
						car_pwm[43]=50;
						car_pwm[32]=50;
						car_pwm[42]=255;
						car_pwm[14]=255;
						break;

			case 5:		
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
							car_pwm[car_led[4][i]]=255;
							car_pwm[car_led[8][i]]=255;
							car_pwm[car_led[3][i]]=255;
							car_pwm[car_led[9][i]]=255;
							car_pwm[car_led[2][i]]=255;
							car_pwm[car_led[10][i]]=255;
						}
						car_pwm[7]=50;
						car_pwm[0]=50;
						car_pwm[2]=50;
						car_pwm[28]=50;	
						car_pwm[26]=50;
						car_pwm[24]=50;
						car_pwm[43]=255;
						car_pwm[13]=255;
						break;

			case 6:		
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
							car_pwm[car_led[4][i]]=255;
							car_pwm[car_led[8][i]]=255;
							car_pwm[car_led[3][i]]=255;
							car_pwm[car_led[9][i]]=255;
							car_pwm[car_led[2][i]]=255;
							car_pwm[car_led[10][i]]=255;
							car_pwm[car_led[1][i]]=255;
							car_pwm[car_led[11][i]]=255;
						}
						car_pwm[8]=50;
						car_pwm[0]=50;
						car_pwm[1]=50;
						car_pwm[27]=50;	
						car_pwm[26]=50;
						car_pwm[25]=50;

						break;
		}


		
*/
		out();

	}


}

void mode_0_always_on()
{
	if(led_time>100)
	{
		led_time=0;

		
		unsigned int m,i;
		i=led_lit_mode;
		for(m=0;m<48;m++)
		{
			car_pwm[m]=255;
		}
		out();
		ok_flag=1;
	}
}








void Tm1Init()
{
	
	TM1C=181;	 //
	TM1M=0x12;   //
	TM1IF=0;	//
	TM1IE=1;	//
	T1TR=1;	//
	FGIE=1;		//
}

void delay(unsigned long time)
{
		send_time=0;

	led_time=0;
	while(led_time<time)
	{
		WDTR=0X5au;   		//忴Ź 
		if(led_time==100)
		{
	//		out();
			send_time=0;
		}
	}
}
void mode_show()
{
	switch(led_mode)
	{
		case 0: mode_0_always_on();break;
		case 1:	mode2_show();break;
		case 2: mode1_show();break;
		case 3: mode3_show();break;
		case 4: mode4_show();break;
		default :led_mode=0;break;
	}
	if(need)
	{
		e2_byte(1);

		e2prom_write(1,led_mode);
		need=0;

	}
}

void main()
{
	P3M=0X02;
	P1M=0X00;
	out();

	unsigned int loop_1,loop_2;
	Tm1Init();
	E2promInit();
	first();
	while(1)
	{
		WDTR=0X5au;
		if(ok_flag)
		{
			mode_0_always_on();
			mode_mode=0;
		}
		else
		{
			mode_show();
		}
	}
}


void out()
{
	unsigned int i;
	FGIE=0;
	for(i=0;i<49;i++)
	{
			send(car_pwm[i]);				
	}
	FGIE=1;
}

void send(unsigned int number)
{
sbit	a		=number:0;
sbit	b		=number:1;
sbit	c		=number:2;
sbit	d		=number:3;
sbit	e		=number:4;
sbit	f		=number:5;
sbit	g		=number:6;
sbit	dp		=number:7;
	if(dp)
	{
		send_1;
	}
	else
	{
		send_0;
	}
	if(g)
	{
		send_1;
	}
	else
	{
		send_0;
	}
	if(f)
	{
		send_1;
	}
	else
	{
		send_0;
	}
	if(e)
	{
		send_1;
	}
	else
	{
		send_0;
	}
	if(d)
	{
		send_1;
	}
	else
	{
		send_0;
	}
	if(c)
	{
		send_1;
	}
	else
	{
		send_0;
	}
	if(b)
	{
		send_1;
	}
	else
	{
		send_0;
	}
	if(a)
	{
		l1=1;delay_5u();delay_5u();l1=0;
	}
	else
	{
		l1=1;__asm{nop}__asm{nop};l1=0;
	}

}





void __interrupt[0x08] interrupt_isr(void)
{
	TM1IF=0;	//־λ 0.8ms
	led_time++;
	send_time++;
	if(last_fog_key!=fog_key)
	{
		ok_flag=0;

	}

	last_fog_key=fog_key;
	if(light_key)
	{
		if(key_count>10)
		{
			led_mode++;
			ok_flag=0;
			led_lit_mode=0;
			zf=0;
			mode_mode=0;
			need=1;
		}
		key_count=0;
	}
	else
	{
		if(key_count<200)
		{
			key_count++;
		}
	}





}