#line 1 ".\Src\UU.c"
#line 1 "C:\Sonix\SN8_C_~1.264\C\include\SonixDef.h"



unsigned long GetRollingCode(unsigned int offset);








struct _intrinsicbitfield
{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};













#line 1 ".\Src\UU.c"
#line 1 ".\Include\fc2722.h"

#line 5 ".\Include\fc2722.h"




struct bitRegister{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};

typedef unsigned char BYTE;
typedef unsigned long WORD;
typedef double DWORD;
















sfr	R = 0x82;
sfr	Z = 0x83;
sfr	Y = 0x84;
sfr	PFLAG = 0x86;
sfr	RBANK = 0x87;


 sfr    TM0M    =0X90;
 sfr    TM0CL   =0X91;
 sfr    TM0CH   =0X92;
 sfr    TM0D0L  =0X93;
 sfr    TM0D0H  =0X94;
 sfr    TM0D1L  =0X95;
 sfr    TM0D1H  =0X96;
 sfr    PWM0E   =0X97;

 sfr	SPIC0	=0X98;
 sfr	SPIC1	=0X99;
 sfr	SPIBUF	=0X9A;


 sfr    TM1M    =0XA0;
 sfr    TM1C    =0XA1;
 sfr    TM1D0   =0XA2;
 sfr    TM1D1   =0XA3;
 sfr    TM1D2   =0XA4;
 sfr    TM1D3   =0XA5;
 sfr    PWM1E   =0XA6;

 sfr	I2CCON	=0XA8;
 sfr	I2CADD	=0XA9;
 sfr	I2CBUF	=0XAA;


 sfr    TM2M    =0XB0;
 sfr    TM2C    =0XB1;
 sfr    TM2D0   =0XB2;
 sfr    TM2D1   =0XB3;
 sfr    TM2D2   =0XB4;
 sfr    TM2D3   =0XB5;
 sfr    PWM2E   =0XB6;


 sfr    lcdadr =0x9f;
 sfr    lcddb  =0x9e;
 sfr    lcdseg =0x9d;
 sfr    lcdcom =0x9c;
 sfr    lcdcon =0x9b;


 sfr    E2PCON =0Xab;
 sfr    E2PDB  =0Xac;
 sfr    E2PADL =0Xad;
 sfr    E2ADH  =0Xae;


 sfr    TKCON=  0X88;
 sfr    TKTMD0 =0X89;
 sfr    TKTMCH =0X8B;
 sfr    TKTMCL =0X8C;
 sfr    TKTMRH =0X8D;
 sfr    TKTMRL =0X8E;
 sfr    TKTMIO =0X8F;


 sfr    ADM    =0XB9;
 sfr    ADB    =0XBa;
 sfr    ADR    =0XBb;
 sfr    ADT    =0XBc;
 sfr    VREFH  =0XBd;
 sfr    ADPCON =0Xbe;
 sfr	PEDGE  =0XBF;


 sfr    P1W    =0XC0;
 sfr	P1M    =0xC1;
 sfr	P2M    =0XC2;
 sfr	P3M    =0XC3;
 sfr    INTRQ1 =0XC6;
 sfr    INTEN1 =0XC7;

 sfr    INTRQ  =0XC8;
 sfr    INTEN  =0XC9;
 sfr	OSCM   =0xCA;
 sfr	RCADJ  =0XCB;
 sfr	WDTR   =0XCC;
 sfr    OPTION =0XCD;
 sfr	PCL    =0XCE;
 sfr	PCH    =0XCF;


 sfr	P1     =0XD1;
 sfr	P2     =0XD2;
 sfr	P3     =0XD3;
 sfr	T0M    =0XD8;
 sfr	T0C    =0XD9;
 sfr    OPA1CON=0XDA;
 sfr    OPA2CON=0XDB;
 sfr    P1OD   =0XDC;
 sfr    P2W    =0Xdd;
 sfr    P3W    =0XDE;
 sfr    STKP   =0XDF;


 sfr	P1UR=0XE1;
 sfr	P2UR=0XE2;
 sfr	P3UR=0XE3;


sbit	E2P_ER_HALF =0xAB:5;
sbit	E2P_BER	    =0xAB:4;
sbit	E2P_CER	    =0xAB:3;
sbit	E2P_SER		=0xAb:2;
sbit	E2P_PG		=0xAb:1;
sbit	E2P_RD		=0xAb:0;

sbit	SPIEN		=0x98:0;

sbit	WCOL		=0x99:1;
sbit	CSEN		=0x99:2;
sbit	MLS		    =0x99:3;
sbit	CKEG		=0x99:4;
sbit	CKPOLB		=0x99:5;


sbit	I2CEN		=0xA8:0;
sbit	I2CPU		=0xA8:1;
sbit	I2CCKP		=0xA8:2;
sbit	TXAK		=0xA8:3;
sbit	SRW		    =0xA8:4;
sbit	HBB		    =0xA8:5;
sbit	HAAS		=0xA8:6;
sbit	HCF		    =0xA8:7;


sbit	TKM0S0		=0x88:0;
sbit	TKM0S1		=0x88:1;
sbit	TKTMPS0		=0x88:2;
sbit	TKTMPS1		=0x88:3;
sbit	TKM0EN		=0x88:4;
sbit	TKM1EN		=0x88:5;
sbit	TKTMSC		=0x88:6;
sbit	TKEN		=0x88:7;

sbit	TKM1S0		=0x89:0;
sbit	TKM1S1		=0x89:1;
sbit	TKRDS0		=0x89:2;
sbit	TKTCEN		=0x89:3;
sbit	TKTCFS0		=0x89:4;
sbit	TKTCFS1		=0x89:5;
sbit	TKTCFS2		=0x89:6;
sbit	TKTMREN		=0x89:7;








sbit	LCDEN		=0x9B:0;
sbit	RESL0		=0x9B:1;
sbit	RESL1		=0x9B:2;
sbit	OSCS		=0x9B:3;
sbit	LCDT0		=0x9B:4;
sbit	LCDT1		=0x9B:5;
sbit	LCDRC_EN	=0x9B:6;



sbit	WDTP0		=0xCD:0;
sbit	WDTP1		=0xCD:1;
sbit	WDTP2		=0xCD:2;
sbit	RTCCON		=0xCD:3;
sbit	LVDTEN		=0xCD:4;
sbit	LDOEN		=0xCD:5;
sbit	LIRC_EN		=0xCD:6;
sbit	RCADJEN		=0xCD:7;




sbit	CHS0		=0xB9:0;
sbit	CHS1		=0xB9:1;
sbit	CHS2		=0xB9:2;
sbit	CHS3		=0xB9:3;
sbit	GCHS		=0xB9:4;
sbit	EOC			=0xB9:5;
sbit	ADS			=0xB9:6;
sbit	ADENB		=0xB9:7;



sbit	ADCKS0		=0xBB:4;
sbit	ADCKS1		=0xBB:6;



sbit	ADT_0		=0xBc:0;
sbit	ADT_1		=0xBC:1;
sbit	ADT_2		=0xBC:2;
sbit	ADT_3		=0xBC:3;
sbit	ADT_4		=0xBC:4;

sbit	adts_0		=0xBC:6;
sbit	adts_1		=0xBC:7;


sbit	VHS0		=0xBD:0;
sbit	VHS1		=0xBD:1;

sbit	EVHENB		=0xBD:7;



sbit	PWM0OE		=0x90:0;
sbit	ALOAD0		=0x90:1;
sbit	T0CKS0		=0x90:2;
sbit	T0CKS1		=0x90:3;
sbit	T0PS0		=0x90:4;
sbit	T0PS1		=0x90:5;
sbit	T0PS2		=0x90:6;
sbit	T0TR		=0x90:7;

sbit	PWM1OE		=0xA0:0;
sbit	ALOAD1		=0xA0:1;
sbit	T1CKS0		=0xA0:2;
sbit	T1CKS1		=0xA0:3;
sbit	T1PS0		=0xA0:4;
sbit	T1PS1		=0xA0:5;
sbit	T1PS2		=0xA0:6;
sbit	T1TR		=0xA0:7;

sbit	PWM2OE		=0xB0:0;
sbit	ALOAD2		=0xB0:1;
sbit	T2CKS0		=0xB0:2;
sbit	T2CKS1		=0xB0:3;
sbit	T2PS0		=0xB0:4;
sbit	T2PS1		=0xB0:5;
sbit	T2PS2		=0xB0:6;
sbit	T2TR		=0xB0:7;


sbit	PWM01E		=0x97:0;
sbit	PWM00HL		=0x97:1;
sbit	PWM01HL		=0x97:2;
sbit	PWM0M		=0x97:3;
sbit	PWM00OE		=0x97:4;
sbit	PWM01OE		=0x97:5;
sbit	TC0WAKE		=0x97:6;
sbit	PWM0OD		=0x97:7;

sbit	PWM11E		=0xA7:0;
sbit	PWM10HL		=0xA7:1;
sbit	PWM11HL		=0xA7:2;
sbit	PWM1M		=0xA7:3;
sbit	PWM10OE		=0xA7:4;
sbit	PWM11OE		=0xA7:5;
sbit	TC1WAKE		=0xA7:6;
sbit	PWM1OD		=0xA7:7;

sbit	PWM21E		=0xB7:0;
sbit	PWM20HL		=0xB7:1;
sbit	PWM21HL		=0xB7:2;
sbit	PWM2M		=0xB7:3;
sbit	PWM20OE		=0xB7:4;
sbit	PWM21OE		=0xB7:5;
sbit	TC2WAKE		=0xB7:6;
sbit	PWM2OD		=0xB7:7;



sbit	INT0IE		=0xc9:0;
sbit	INT1IE		=0xc9:1;
sbit	TM0IE		=0xc9:2;
sbit	TM1IE		=0xc9:3;
sbit	TM2IE		=0xc9:4;
sbit	RPIE		=0xc9:5;
sbit	I2CIE		=0xc9:6;
sbit	ADCIE		=0xc9:7;

sbit	E2PIE		=0xc7:0;
sbit	TKTMRIE		=0xc7:1;
sbit	SPIIE		=0xc7:2;
sbit	T0IE	    =0xC7:3;
sbit	OPAIE    	=0xC7:4;

sbit	INT0IF		=0xc8:0;
sbit	INT1IF		=0xc8:1;
sbit	TM0IF		=0xc8:2;
sbit	TM1IF		=0xc8:3;
sbit	TM2IF		=0xc8:4;
sbit	RPIF		=0xc8:5;
sbit	I2CIF		=0xc8:6;
sbit	ADCIF		=0xc8:7;

sbit	E2PIF		=0xc6:0;
sbit	TKTMRIF		=0xc6:1;
sbit	SPIIF		=0xc6:2;
sbit	T0IF	    =0xC6:3;
sbit	OPAIF    	=0xC6:4;

sbit	FP17 = 0xd1:7;
sbit	FP16 = 0xd1:6;
sbit	FP15 = 0xd1:5;
sbit	FP14 = 0xd1:4;
sbit	FP13 = 0xd1:3;
sbit	FP12 = 0xd1:2;
sbit	FP11 = 0xd1:1;
sbit	FP10 = 0xd1:0;

sbit	FP25 = 0xd2:5;
sbit	FP24 = 0xd2:4;
sbit	FP23 = 0xd2:3;
sbit	FP22 = 0xd2:2;
sbit	FP21 = 0xd2:1;
sbit	FP20 = 0xd2:0;

sbit	FP37 = 0xd3:7;
sbit	FP36 = 0xd3:6;
sbit	FP35 = 0xd3:5;
sbit	FP34 = 0xd3:4;
sbit	FP33 = 0xd3:3;
sbit	FP32 = 0xd3:2;
sbit	FP31 = 0xd3:1;
sbit	FP30 = 0xd3:0;



sbit	FCLKMD = 0xca:2;
sbit	FSTPHX = 0xca:1;

sbit	FGIE   = 0xDF:7;

sbit	FSTKPB2= 0xDF:2;
sbit	FSTKPB1= 0xDF:1;
sbit	FSTKPB0= 0xDF:0;
















#line 2 ".\Src\UU.c"

#line 1 ".\Include\E2PROM.h"




void E2promInit(void);
void e2prom_write(unsigned int e2_adders,unsigned int e2_data);
unsigned int e2prom_read(unsigned int e2_adders);

void  e2_c();
void  e2_s(unsigned int e2_adders);
void  e2_byte(unsigned int e2_adders);


#line 4 ".\Src\UU.c"








unsigned long led_time=0;

unsigned int send_time=0;
void send(unsigned int number);
void out();
unsigned int car_led[13][3]={
							{8,0,1},
							{7,13,2},
							{6,14,3},
							{11,15,4},
							{10,16,5},
							{9,17,33},
							{18,20,34},
							{23,45,35},
							{22,46,30},
							{21,47,31},
							{29,42,32},
							{28,43,24},
							{27,26,25},
};

unsigned int car_pwm[48]={0};

unsigned int key_count;
void delay(unsigned long time);

void delay_5u()
{}


unsigned int led_mode=1;
unsigned int led_lit_mode;
unsigned int mode_mode=0;
bit zf;

bit ok_flag=0;
bit last_fog_key=0;
bit need;

void first()
{

	unsigned int i;

	i=e2prom_read(2);
	if(i==0x69)
	{
		led_mode=e2prom_read(1);
	}
	else
	{
			e2_c();
		e2prom_write(1,1);
		e2prom_write(2,0x69);
	}
}















void mode1_show()
{
	if(led_time>100)
	{
		led_time=0;
		if(zf)
		{
			led_lit_mode++;
			if(led_lit_mode>11)
			{
				zf=0;
				led_lit_mode=11;
			}

		}
		else
		{
			if(led_lit_mode==0)
			{
				zf=1;
				led_lit_mode=0;
			}
			else
			{
				led_lit_mode--;
			}
		}
		unsigned int m,i;
		i=led_lit_mode;
		for(m=0;m<48;m++)
		{
			car_pwm[m]=0;
		}
		if(i==6||i==5)
		{
			car_pwm[19]=255;
			car_pwm[12]=255;
		}


		car_pwm[car_led[i][0]]=255;
		car_pwm[car_led[i][1]]=255;
		car_pwm[car_led[i][2]]=255;
		car_pwm[car_led[i+1][0]]=255;
		car_pwm[car_led[i+1][1]]=255;
		car_pwm[car_led[i+1][2]]=255;
		out();
	}
}





void mode3_show()
{
	if(led_time>100)
	{
		led_time=0;
		if(zf)
		{
			led_lit_mode++;
			if(led_lit_mode>13)
			{
				zf=0;
				led_lit_mode=13;
				mode_mode++;
				if(mode_mode>=2)
				{
					ok_flag=1;
				}
			}

		}
		else
		{
			if(led_lit_mode==0)
			{
				zf=1;
				led_lit_mode=0;
			}
			else
			{
				led_lit_mode--;
			}
		}
		unsigned int m,i;
		i=led_lit_mode;
		for(m=0;m<48;m++)
		{
			car_pwm[m]=0;
		}

		for(i=0;i<led_lit_mode;i++)
		{
			car_pwm[car_led[i][0]]=255;
			car_pwm[car_led[i][1]]=255;
			car_pwm[car_led[i][2]]=255;

		}
		if(i>6)
		{
			car_pwm[19]=255;
			car_pwm[12]=255;
		}


		out();
	}
}



void mode4_show()
{
	if(led_time>200)
	{
		led_time=0;
		led_lit_mode++;

		unsigned int m,i;
		switch(mode_mode)
		{
			case 0:
					for(m=0;m<48;m++)
					{
						car_pwm[m]=0;
					}
					mode_mode=1;
					led_lit_mode=0;
					break;
			case 1:

					car_pwm[car_led[6-led_lit_mode][0]]=255;
					if(led_lit_mode==6)
					{
						mode_mode=2;
						led_lit_mode=0;
					}
					break;

			case 2:
					car_pwm[0]=255;
					mode_mode=3;
					led_lit_mode=0;
					break;
			case 3:
					car_pwm[car_led[led_lit_mode-1][2]]=255;
					if(led_lit_mode==13)
					{
						mode_mode=4;
						led_lit_mode=0;
					}
					break;
			case 4:
					car_pwm[26]=255;
					mode_mode=5;
					led_lit_mode=0;
					break;
			case 5:
					car_pwm[car_led[13-led_lit_mode][0]]=255;
					if(led_lit_mode==7)
					{
						mode_mode=6;
						led_lit_mode=0;
					}
					break;

			case 6:
					car_pwm[19]=255;
					mode_mode=7;
					led_lit_mode=0;
					break;
			case 7:
					car_pwm[20]=255;
					mode_mode=8;
					led_lit_mode=0;
					break;
			case 8:
					car_pwm[12]=255;
					mode_mode=9;
					led_lit_mode=0;
					break;

			case 9:
					if(led_lit_mode==6)
					{
						led_lit_mode=7;
					}
					car_pwm[car_led[led_lit_mode][1]]=255;
					if(led_lit_mode==11)
					{
						led_lit_mode=0;
						mode_mode=10;

					}
					break;
			default :
						ok_flag=1;
				break;




		}



		out();
	}
}

void mode2_show()
{
	if(led_time>200)
	{
		led_time=0;
		if(zf)
		{
			led_lit_mode++;
			if(led_lit_mode>7)
			{
				zf=0;
				led_lit_mode=7;
			}

		}
		else
		{
			if(led_lit_mode==0)
			{
				zf=1;
				led_lit_mode=0;
			}
			else
			{
				led_lit_mode--;
			}
		}

		unsigned int m,i;
		i=led_lit_mode;
		for(m=0;m<48;m++)
		{
			car_pwm[m]=0;
		}

		car_pwm[20]=255;



		switch(led_lit_mode)
		{
			case 0:	break;
			case 1:
						car_pwm[19]=255;
						car_pwm[12]=255;
						car_pwm[17]=255;
						car_pwm[45]=255;
						break;

			case 2:
						car_pwm[19]=255;
						car_pwm[12]=255;
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
						}
						car_pwm[car_led[8][1]]=255;
						car_pwm[car_led[4][1]]=255;
						break;

			case 3:
						car_pwm[19]=255;
						car_pwm[12]=255;
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
							car_pwm[car_led[8][i]]=255;
							car_pwm[car_led[4][i]]=255;
						}
						car_pwm[car_led[9][1]]=255;
						car_pwm[car_led[3][1]]=255;
						break;


			case 4:
						car_pwm[19]=255;
						car_pwm[12]=255;
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
							car_pwm[car_led[8][i]]=255;
							car_pwm[car_led[4][i]]=255;
							car_pwm[car_led[9][i]]=255;
							car_pwm[car_led[3][i]]=255;
						}
						car_pwm[car_led[10][1]]=255;
						car_pwm[car_led[2][1]]=255;
						break;


			case 5:
						car_pwm[19]=255;
						car_pwm[12]=255;
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
							car_pwm[car_led[8][i]]=255;
							car_pwm[car_led[4][i]]=255;
							car_pwm[car_led[9][i]]=255;
							car_pwm[car_led[3][i]]=255;
							car_pwm[car_led[10][i]]=255;
							car_pwm[car_led[2][i]]=255;
						}
						car_pwm[car_led[11][1]]=255;
						car_pwm[car_led[1][1]]=255;
						break;

			case 6:
						car_pwm[19]=255;
						car_pwm[12]=255;
						for(i=0;i<3;i++)
						{
							car_pwm[car_led[6][i]]=255;
							car_pwm[car_led[5][i]]=255;
							car_pwm[car_led[7][i]]=255;
							car_pwm[car_led[8][i]]=255;
							car_pwm[car_led[4][i]]=255;
							car_pwm[car_led[9][i]]=255;
							car_pwm[car_led[3][i]]=255;
							car_pwm[car_led[10][i]]=255;
							car_pwm[car_led[2][i]]=255;
							car_pwm[car_led[11][i]]=255;
							car_pwm[car_led[1][i]]=255;
						}
						car_pwm[car_led[12][1]]=255;
						car_pwm[car_led[0][1]]=255;
						break;
			case 7:
						for(m=0;m<48;m++)
						{
							car_pwm[m]=255;
						}
						mode_mode++;
						if(mode_mode>=4)
						{
							ok_flag=1;
						}
						break;
			default	:led_lit_mode=0;break;
		}




#line 581 ".\Src\UU.c"
		out();

	}


}

void mode_0_always_on()
{
	if(led_time>100)
	{
		led_time=0;


		unsigned int m,i;
		i=led_lit_mode;
		for(m=0;m<48;m++)
		{
			car_pwm[m]=255;
		}
		out();
		ok_flag=1;
	}
}








void Tm1Init()
{

	TM1C=181;
	TM1M=0x12;
	TM1IF=0;
	TM1IE=1;
	T1TR=1;
	FGIE=1;
}

void delay(unsigned long time)
{
		send_time=0;

	led_time=0;
	while(led_time<time)
	{
		WDTR=0X5au;
		if(led_time==100)
		{

			send_time=0;
		}
	}
}
void mode_show()
{
	switch(led_mode)
	{
		case 0: mode_0_always_on();break;
		case 1:	mode2_show();break;
		case 2: mode1_show();break;
		case 3: mode3_show();break;
		case 4: mode4_show();break;
		default :led_mode=0;break;
	}
	if(need)
	{
		e2_byte(1);

		e2prom_write(1,led_mode);
		need=0;

	}
}

void main()
{
	P3M=0X02;
	P1M=0X00;
	out();

	unsigned int loop_1,loop_2;
	Tm1Init();
	E2promInit();
	first();
	while(1)
	{
		WDTR=0X5au;
		if(ok_flag)
		{
			mode_0_always_on();
			mode_mode=0;
		}
		else
		{
			mode_show();
		}
	}
}


void out()
{
	unsigned int i;
	FGIE=0;
	for(i=0;i<49;i++)
	{
			send(car_pwm[i]);
	}
	FGIE=1;
}

void send(unsigned int number)
{
sbit	a		=number:0;
sbit	b		=number:1;
sbit	c		=number:2;
sbit	d		=number:3;
sbit	e		=number:4;
sbit	f		=number:5;
sbit	g		=number:6;
sbit	dp		=number:7;
	if(dp)
	{
 FP31 =1;delay_5u();delay_5u();FP31 =0;__asm{nop}__asm{nop};;
	}
	else
	{
 FP31 =1;__asm{nop}__asm{nop};FP31 =0;__asm{nop};delay_5u();;
	}
	if(g)
	{
 FP31 =1;delay_5u();delay_5u();FP31 =0;__asm{nop}__asm{nop};;
	}
	else
	{
 FP31 =1;__asm{nop}__asm{nop};FP31 =0;__asm{nop};delay_5u();;
	}
	if(f)
	{
 FP31 =1;delay_5u();delay_5u();FP31 =0;__asm{nop}__asm{nop};;
	}
	else
	{
 FP31 =1;__asm{nop}__asm{nop};FP31 =0;__asm{nop};delay_5u();;
	}
	if(e)
	{
 FP31 =1;delay_5u();delay_5u();FP31 =0;__asm{nop}__asm{nop};;
	}
	else
	{
 FP31 =1;__asm{nop}__asm{nop};FP31 =0;__asm{nop};delay_5u();;
	}
	if(d)
	{
 FP31 =1;delay_5u();delay_5u();FP31 =0;__asm{nop}__asm{nop};;
	}
	else
	{
 FP31 =1;__asm{nop}__asm{nop};FP31 =0;__asm{nop};delay_5u();;
	}
	if(c)
	{
 FP31 =1;delay_5u();delay_5u();FP31 =0;__asm{nop}__asm{nop};;
	}
	else
	{
 FP31 =1;__asm{nop}__asm{nop};FP31 =0;__asm{nop};delay_5u();;
	}
	if(b)
	{
 FP31 =1;delay_5u();delay_5u();FP31 =0;__asm{nop}__asm{nop};;
	}
	else
	{
 FP31 =1;__asm{nop}__asm{nop};FP31 =0;__asm{nop};delay_5u();;
	}
	if(a)
	{
 FP31 =1;delay_5u();delay_5u();FP31 =0;
	}
	else
	{
 FP31 =1;__asm{nop}__asm{nop};FP31 =0;
	}

}





void __interrupt[0x08] interrupt_isr(void)
{
	TM1IF=0;
	led_time++;
	send_time++;
	if(last_fog_key!= FP11)
	{
		ok_flag=0;

	}

	last_fog_key= FP11;
	if(FP12)
	{
		if(key_count>10)
		{
			led_mode++;
			ok_flag=0;
			led_lit_mode=0;
			zf=0;
			mode_mode=0;
			need=1;
		}
		key_count=0;
	}
	else
	{
		if(key_count<200)
		{
			key_count++;
		}
	}





}
